// $Id: ObjectPipeBeanInfo.java,v 1.4 1999/06/23 17:52:06 beca Exp $
/*
File: ObjectPipeBeanInfo.java
Component: Plugin
Date            Author        Changes
Aug 05 98       Lukasz Beca   Created
*/

package webwisdom.tango.beans;



import java.beans.*;

import java.awt.event.*;

import symantec.itools.beans.*;


/*

**    BeanInfo for JavaBean:

*/

public class ObjectPipeBeanInfo extends SimpleBeanInfo

{



    // getIcon returns an image object which can be used by toolboxes, toolbars

    // to represent this bean. Icon images are in GIF format.

    public java.awt.Image getIcon(int iconKind)

    {

        if (iconKind == BeanInfo.ICON_COLOR_16x16 ||

            iconKind == BeanInfo.ICON_MONO_16x16)

        {

            java.awt.Image img = loadImage("objectpipe.gif");

            return img;

        }

        if (iconKind == BeanInfo.ICON_COLOR_32x32 ||

            iconKind == BeanInfo.ICON_MONO_32x32)

        {

            java.awt.Image img = loadImage("objectpipe.gif");

            return img;

        }

        return null;

    }

    
    public BeanDescriptor getBeanDescriptor() {
		
    	SymantecBeanDescriptor bd = new SymantecBeanDescriptor(beanClass);			
    	bd.setFolder("Tango Beans");
    	bd.setToolbar("Tango Beans");
    	
    	//new vc changes
    	
        ConnectionDescriptor SendDataDescriptor = new ConnectionDescriptor( );
	    SendDataDescriptor.setForm(ConnectionDescriptor.INPUT);   
        SendDataDescriptor.setType("java.lang.Object");
	    SendDataDescriptor.setExpr("%name%.sendData(%arg%);" );
	    SendDataDescriptor.setShortDescription("Send data to all participants");
	    bd.addConnectionDescriptor(SendDataDescriptor);
	    
	    ConnectionDescriptor SelectSendDataDescriptor = new ConnectionDescriptor( );
	    SelectSendDataDescriptor.setForm(ConnectionDescriptor.INPUT);   
        SelectSendDataDescriptor.setType("java.lang.Object");
	    SelectSendDataDescriptor.setExpr("%name%.selectiveSendData(%arg%);" );
	    SelectSendDataDescriptor.setShortDescription("Send data to selected participants");
	    bd.addConnectionDescriptor(SelectSendDataDescriptor);
	    
	    ConnectionDescriptor SelectDescriptor = new ConnectionDescriptor( );
	    SelectDescriptor.setForm(ConnectionDescriptor.INPUT);   
        SelectDescriptor.setType("java.lang.String[]");
	    SelectDescriptor.setExpr("%name%.selectRecipients(%arg%);" );
	    SelectDescriptor.setShortDescription("Select participants for data send");
	    bd.addConnectionDescriptor(SelectDescriptor); 	    	       	   	   
    	    	
    	return (BeanDescriptor) bd;
	
	}
    
    
        

     public MethodDescriptor[] getMethodDescriptors() {

     

        Class parameters[] = new Class[1];

        Class selective[] = new Class[1];
        
        //latest
        
        Class condition[] = new Class[2];
        
        condition[0] = Object.class;
        condition[1] = boolean.class;        
        
        // end of latest

        parameters[0] = Object.class;

        selective[0] = String[].class;       
        

        try {

        

            MethodDescriptor sendDataMethod = new MethodDescriptor(ObjectPipe.class.getMethod("sendData", parameters));
            sendDataMethod.setDisplayName("Send data to all participants");

            MethodDescriptor selectiveSendDataMethod = new MethodDescriptor(ObjectPipe.class.getMethod("selectiveSendData", parameters));
            selectiveSendDataMethod.setDisplayName("Send data to selected participants");
            
            MethodDescriptor selectMethod = new MethodDescriptor(ObjectPipe.class.getMethod("selectRecipients", selective));
            selectMethod.setDisplayName("Select participants for data send");
            
            //latest
            MethodDescriptor sendDataOnConditionMethod = new MethodDescriptor(ObjectPipe.class.getMethod("sendDataOnCondition", condition));
            sendDataOnConditionMethod.setDisplayName("Send data on condition to all participants");
            
            MethodDescriptor selectiveSendDataOnConditionMethod = new MethodDescriptor(ObjectPipe.class.getMethod("selectiveSendDataOnCondition", condition));
            selectiveSendDataOnConditionMethod.setDisplayName("Send data on condition to selected participants");
            
            //end of latest
                       
                       
            MethodDescriptor rv[] = {sendDataMethod, selectMethod, selectiveSendDataMethod, sendDataOnConditionMethod, selectiveSendDataOnConditionMethod};

            return rv;

        } catch(NoSuchMethodException e) {

         

            throw new Error(e.toString());            

        }

       

        

        

    }



    // getPropertyDescriptors returns an array of PropertyDescriptors which describe

    // the editable properties of this bean.



       public PropertyDescriptor[] getPropertyDescriptors()

    {

                     

        PropertyDescriptor rv[] = {};

        return rv;

        

    }





    public EventSetDescriptor[] getEventSetDescriptors() {



              try

        {

            EventSetDescriptor dataArrived = new EventSetDescriptor(beanClass, "data", dataListenerClass, "dataArrived");            

            dataArrived.setDisplayName("Data arrived");            

            EventSetDescriptor connectPipe = new EventSetDescriptor(beanClass, "pipeConnect", connectListenerClass, "pipeReady");            

            connectPipe.setDisplayName("Pipe ready to connect");

            EventSetDescriptor rv[] = {dataArrived, connectPipe};

            return rv;

        }

        catch (IntrospectionException e)

        {

            throw new Error(e.toString());

        }

    }









    private final static Class beanClass = ObjectPipe.class;

    private final static Class dataListenerClass = PipeDataListener.class;

    private final static Class connectListenerClass = PipeConnectListener.class;

}