// $Id: LocalBase.java,v 1.28 1999/05/14 17:31:30 toma Exp $
/*
  File: LocalBase.java
  Component: Plugin
  Date		Author		Changes
  Mar 07 97	Lukasz Beca	Created
*/

package webwisdom.tango.structures;

import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.structures.Registrar;
import webwisdom.tango.interfaces.PureJavaInterface;
import netscape.plugin.Plugin;
import webwisdom.tango.structures.ScriptHandle;
import netscape.javascript.JSObject;
import netscape.security.PrivilegeManager;
import webwisdom.tango.test.Log;

import java.util.StringTokenizer;


public class LocalBase extends Plugin
{
    private static final String CL="LocalBase";

    //////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////
    // DO NOT EDIT THE NEXT LINE!  IT WILL BE GENERATED AUTOMATICALLY!
    private static String compilationDate = "*Build: unused*";
    //////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////
    
    private String serverHost;
    private int serverPort,localPort;

    private ControlApplication ca;
    public Registrar reg;


    private static LocalBase localBase=null;


    public LocalBase()
    {
      System.out.println(CL+": TANGO Interactive v. "+getPluginVersion()+" built 5/14/99 (before vacations)");

 //     if(Const.inNetscape())
//	{
	  try {
	  
	    Log.init(3);
	    Log.out.println(CL+": TANGO Interactive Plugin, "+getPluginVersion(),0);
	    
	  } catch(Exception e) {
	  
	     e.printStackTrace();
	    
	  } 



/*	  serverHost=new String(getServerHost());
	  if(serverHost==null)
	    throw new Error("serverHost=null");
	  if(serverHost.equals("*"))
	    throw new Error("serverHost=\"*\" (invalid)");

	  serverPort=getServerPort();
	  if(serverPort==-1)
	    throw new Error("serverPort=-1"); */

	  localPort=getLocalPort();
	  if(localPort==-1)
	    throw new Error("localPort=-1");
//	}
//      else
//	{
	/*  PureJavaInterface pji=PureJavaInterface.getPureJavaInterface();
	  serverHost=pji.getHost();
	  serverPort=pji.getServerPort();
	  localPort=pji.getLocalPort(); */
//	}

//      System.out.println(CL+".LocalBase(): server="+serverHost+
//			 ":"+serverPort+" localPort="+localPort);

      ca=new ControlApplication();
      reg=new Registrar(localPort, this, ca);

      //System.out.println(CL+".LocalBase(): ca="+ca+" reg="+reg);
	
      localBase=this;
    }// LocalBase __________________________________________________________


    public static LocalBase getLocalBase()
    {
      if(localBase==null)
	localBase=new LocalBase();
      return localBase;
    }// getLocalBase _______________________________________________________
  

    public void init()
    {
       Log.out.println(CL+".init()", 2);
       
     }// init _______________________________________________________________

    
    public void destroy()
    {
	Log.out.println(CL+".destroy()", 2);
	ca.terminated();
	ca=null;
	reg=null;
    }// destroy ____________________________________________________________


    /**interface for ControlApplication*/
    
    public synchronized void connect() {
    
      Log.out.println(CL+".connect()", 2);
      PrivilegeManager.enablePrivilege("30Capabilities");
      LocalApplications apps=new LocalApplications();   
      reg.initAssociations(apps);        
//      CentralServer cs=new CentralServer(serverHost,serverPort);
      CentralServer cs=new CentralServer();
      ca.initAssociations(this,cs,apps,reg);
      cs.initAssociations(ca,apps);
      apps.initAssociations(ca,cs);
      Log.out.println(CL+".connect(): end", 2);
	    
    }// connect ____________________________________________________________
    
    
    public synchronized void startApplication(String path,
					      int AID,int SID,int AT,
					      int localport)
    {
	runApplication(path,AID,SID,AT,localport);
    }// startApplication ___________________________________________________


    /**interface for scripts
     not used with new api*/
    public ScriptHandle addScript(JSObject window,
				  String AIDs,String SIDs,String ATs)
    {
	return reg.registerScript(window, AIDs, SIDs, ATs);
    }// addScript __________________________________________________________
   
   
    private native int runApplication(String path,
				      int AID,int SID,int AT,
				      int port);
    // runApplication ______________________________________________________
   

    /**
     *@return "*" if not available*/
    private native String getServerHost();
    // getServerHost _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getServerPort();
    // getServerPort _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getLocalPort();
    // getLocalPort ________________________________________________________
    
     /**
     *@return 0 if not available, 1 otherwise*/
    private native int audioAvailable();
    // audioAvailable ________________________________________________________
    

    public static boolean isAudioAvailable()
    {
      //System.out.println(CL+".isAudioAvailable(): localBase="+localBase);
      if(localBase==null)
	return true;
      boolean result=(localBase.audioAvailable()==1);
      //System.out.println(CL+".isAudioAvailable()="+result);
      return result;
    }// isAudioAvailable ___________________________________________________


    public static String getPluginVersion()
    {
      return "2.0.0.9";
    }// getPluginVersion __________________________________________________


}// LocalBase //////////////////////////////////////////////////////////////
